module     p0_dubar_emnebar_abbrevh0
   use p0_dubar_emnebar_config, only: ki
   use p0_dubar_emnebar_globalsh0
   implicit none
   private
   complex(ki), public :: abb1n1
   complex(ki), public :: abb1n2
   complex(ki), public :: abb1n3
   complex(ki), public :: abb1n4
   complex(ki), public :: abb1n5
   complex(ki), public :: abb1n6
   complex(ki), public :: abb1n7
   complex(ki), public :: rat2d1
   complex(ki), public :: abb1n9
   complex(ki), public :: abb1n10
   complex(ki), public :: abb1n11
   complex(ki), public :: abb1n12
   complex(ki), public :: abb1n13
   complex(ki), public :: abb1n14
   complex(ki), public :: abb1n15
   complex(ki), public :: abb1n16
   complex(ki), public :: abb1n17
   complex(ki), public :: abb1n18
   complex(ki), public :: abb1n19

   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_dubar_emnebar_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use p0_dubar_emnebar_kinematics
      use p0_dubar_emnebar_model
      use p0_dubar_emnebar_color, only: TR
      use p0_dubar_emnebar_globalsl1, only: epspow
      implicit none
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      t1 = es12+wW*mW*i_-mW*mW
      t2 = TR*c1
      t3 = t2*i_
      t4 = t3*spak2k3
      t5 = NC*t1
      t6 = t4/t5*spbk4k1
      t7 = NC*TR*c1
      t8 = t7*i_
      t9 = t8*spak2k3
      t10 = t9/t1*spbk4k1
      abb1n1 = (t10-t6)
      abb1n2 = ((2.0_ki)*(es12*t7/t1*i_*spak2k3*spbk4k1-es12*t2/t5*i_*spak2k3*sp&
      &bk4k1))
      abb1n3 = ((2.0_ki)*(t3/t5*spak1k2*spbk4k1-t8/t1*spak1k2*spbk4k1))
      t2 = t6-t10
      abb1n4 = ((4.0_ki)*t2)
      abb1n5 = ((2.0_ki)*t2)
      abb1n6 = ((2.0_ki)*(t9/t1*spbk4k2-t4/t5*spbk4k2))
      abb1n7 = ((2.0_ki)*(t8/t1-t3/t5))
      rat2d1 = abb1n1
      rat2 = rat2 + rat2d1
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='1' value='", &
          & rat2d1, "'/>"
      end if
      abb1n9 = abb1n2
      abb1n10 = abb1n7
      abb1n11 = abb1n6
      abb1n12 = abb1n5
      abb1n13 = abb1n4
      abb1n14 = abb1n3
      abb1n15 = -(abb1n3)
      abb1n16 = -(abb1n4)
      abb1n17 = (-2.0_ki)*abb1n5
      abb1n18 = -(abb1n6)
      abb1n19 = -(abb1n7)
   end subroutine
end module p0_dubar_emnebar_abbrevh0
